;+
; NAME:
;       CH_CURSOR_MOTION
; PURPOSE:
;       Cursor communication with ENVI image windows
; AUTHOR;
;       Mort Canty (2006)
;       Juelich Research Center
;       m.canty@fz-juelich.de
; CALLING SEQUENCE:
;       CH_Cursor_Motion, dn, xloc, yloc, $
;       xstart=xstart, ystart=ystart, event=event
; ARGUMENTS:
;       dn: display number
;       xloc,yloc: mouse position
; KEYWORDS
;       xstart, ystart: display origin
;       event: mouse event
; COMMON BLOCKS:
;       Cursor_Motion_C,dn,Cbtext,Rbtext,Cttext,Rttext
; DEPENDENCIES:
;       ENVI
;----------------------------------------------------
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
;----------------------------------------------------------

pro ch_cursor_motion, dn1, xloc, yloc, xstart=xstart, ystart=ystart, event=event
common cursor_motion_c, dn, Cbtext, Rbtext, Cttext, Rttext
  dn = dn1
  if (n_elements(Cbtext) eq 0) then Cbtext = -1L
  if (widget_info(Cbtext, /valid_id) eq 1) then begin
     if (event.press eq 1) and (event.modifiers eq 0) then begin
        widget_control, Cbtext, set_value = strtrim(xloc+1,2)
        widget_control, Rbtext, set_value = strtrim(yloc+1,2)
     endif
     if (event.press eq 1) and (event.modifiers eq 1) then begin
        widget_control, Cttext, set_value = strtrim(xloc+1,2)
        widget_control, Rttext, set_value = strtrim(yloc+1,2)
     endif
  endif
end
