pro solution4_1

; get an image band from ENVI
envi_select, title='Choose multispectral band', $
             fid=fid, dims=dims,pos=pos, /band_only
if (fid eq -1) then begin
   print, 'cancelled'
   return
endif
num_cols = (c = dims[2]-dims[1]+1)
num_rows = (r = dims[4]-dims[3]+1)
g = float(envi_get_data(fid=fid,dims=dims,pos=pos))

; define a 3 x 3 weighted average filter
h = [[1,2,1],[2,4,2],[1,2,1]]/16.0

; convolve in the spatial domain
envi_enter_data, convol(g,h,center=0)

; pad to c + 3 - 1 and r + 3 -1
zeroes = fltarr(2,r)
g = transpose([[transpose(g)],[transpose(zeroes)]])
zeroes = fltarr(c+2,2)
g = [[g],[zeroes]]
hp = g*0
hp[0:2,0:2] = h

; convolve in the frequency domain
envi_enter_data, fft(c*fft(g)*fft(hp),1)

end

