pro solution4_2

envi_select, title='Choose multispectral band', $
             fid=fid, dims=dims,pos=pos, /band_only
if (fid eq -1) then begin
   print, 'cancelled'
   return
endif

num_cols = dims[2]-dims[1]+1
num_rows = dims[4]-dims[3]+1

; get the image band from ENVI
g = envi_get_data(fid=fid,dims=dims,pos=pos[0])

; transform it
g_hat = fft(g)

; create a Butterworth filter in the frequency domain
d0 = 50.0
n = 2
d = dist(num_cols,num_rows)
h_hat =  1/(1+(d/d0)^(2*n))

; output surface plot of filter as EPS file
thisDevice =!D.Name
set_plot, 'PS'
Device, Filename='c:\temp\fig1.eps',xsize=3,ysize=3, $
         /inches,/encapsulated
shade_surf, shift(h_hat,num_cols/2,num_rows/2)
device,/close_file
set_plot,thisDevice

; multiply, do inverse FFT and return result to ENVI
envi_enter_data, fft(g_hat*h_hat,1)      ; low-pass
envi_enter_data, fft(g_hat*(1-h_hat),1)  ; high-pass

end

