pro solution5_1
   envi_select, title='Choose image band', $
                fid=fid, dims=dims,pos=pos, /band_only
   if (fid eq -1) then begin
      print, 'cancelled'
      return
   endif
   envi_file_query, fid, fname=fname, data_type=data_type
   if data_type ne 1 then begin
      print, 'not byte data, cancelled'
      return
   endif
   image = envi_get_data(fid=fid,dims=dims,pos=pos)
   num_pixels = n_elements(image)
; cumulative sum of the histogram
   hist = histogram(image)
   cusum = lonarr(256)
   for i=1, 255 do cusum[i]=cusum[i-1]+hist[i]
; construct the LUT
   LUT = bytarr(256)
   indices = where( (cusum gt num_pixels*2/100) and $
             (cusum lt num_pixels*98/100) )
   for i=min(indices), max(indices) do $
      LUT[i] = byte( 255.*(i-min(indices))/ $
              (max(indices)-min(indices)) )
   LUT[max(indices):255]=255
; apply it
   tv, LUT[image]
end

