; SUSAN edge detector
; Ref: Smith and Brady, Int J. of Comp. Vision 23(1),
; 45-78 (1997)

pro get_mask, j, x_size, mask
    mask[0]     = (j-3)*x_size + 2
    mask[1:2]   = mask[0] + [1,2]
    mask[3]     = (j-2)*x_size + 1
    mask[4:7]   = mask[3] + [1,2,3,4]
    mask[8]     = (j-1)*x_size
    mask[9:14]  = mask[8] + [1,2,3,4,5,6]
    mask[15]    = j*x_size
    mask[16:21] = mask[15] + [1,2,3,4,5,6]
    mask[22]    = (j+1)*x_size
    mask[23:28] = mask[22] + [1,2,3,4,5,6]
    mask[29]    = (j+2)*x_size +1
    mask[30:33] = mask[29] + [1,2,3,4]
    mask[34]    = (j+3)*x_size + 2
    mask[35:36] = mask[34] + [1,2]
end

Pro solution5_4
; get an image band from ENVI
   envi_select, title='Choose multispectral band', $
             fid=fid, dims=dims,pos=pos, /band_only
   if (fid eq -1) then begin
      print, 'cancelled'
      return
   endif
   num_cols = dims[2]-dims[1]+1
   num_rows = dims[4]-dims[3]+1
   im = bytscl(envi_get_data(fid=fid,dims=dims,pos=pos[0]))
   mask = lonarr(37)
; parameters
   g = 0.75*37
   t = 20.0
; lookup table for c(r,r0) (and plot)
   LUT  = fltarr(256)
   for i=0,255 do LUT[i] = exp(-(i/t)^6)
   gr = lindgen(256)
   thisDevice =!D.Name
   set_plot, 'PS'
   Device, Filename='c:\temp\fig5_1.eps',xsize=5, $
    ysize=3, /inches,/encapsulated
   plot, gr, LUT(abs(gr-127))
   device,/close_file
   set_plot,thisDevice
; run the filter
   out_array = bytarr(num_cols,num_rows)
   progressbar=Obj_New('progressbar',Color='red',Text='0',$
   title='row...',xsize=250,ysize=20)
   progressbar->start
   for j=3L,num_rows-3 do begin
     if progressbar->CheckCancel() then begin
         print,'cancelled'
         progressbar->Destroy
         return
     endif
     progressbar->Update,((j*100)/num_rows),$
           text=strtrim(j,2)
     get_mask, j, num_cols, mask
     for i=3L,num_cols-3 do begin
       out_array[i,j]= $
          (g-total(LUT[abs(im[mask]-im[i,j])]))>0
       mask=mask+1
     endfor
   endfor
   progressbar->Destroy
; return result to ENVI
   envi_enter_data, out_array
end

