Pro solution5_5

envi_select, title='Choose multispectral image', $
             fid=fid, dims=dims,pos=pos
if (fid eq -1) or (n_elements(pos) lt 2) then return

num_cols = dims[2]-dims[1]+1
num_rows = dims[4]-dims[3]+1
num_bands = n_elements(pos)
im = fltarr(num_cols,num_rows,num_bands)

; loop over the spectral bands
for i=0,num_bands-1 do begin
; create an instance of the DWT class
; for each image band and compress
   aDWT = Obj_New('DWT',envi_get_data(fid=fid, $
                        dims=dims,pos=pos[i]))
   aDWT -> compress
   n = aDWT -> get_num_cols()
   m = aDWT -> get_num_rows()
; threshold the wavelet coefficients at 1 sigma
   for j=1,3 do begin
      q = aDWT -> get_quadrant(j)
      sigma = stddev(q)
      mn = mean(q)
      q[where(abs(q-mn) lt 4*sigma)] = 0.0
      aDWT -> inject, reform(q,n,m), quadrant=j
   endfor
   aDWT -> expand
   im[*,*,i] = aDWT -> get_image()
   Obj_Destroy, aDWT
endfor

envi_enter_data, im

End

