pro solution6_3

; linearly separable, labelled training data
n = 100
data = randomu(seed, 2, n)
labels = intarr(n)
for i=0,n-1 do if data[0,i]+data[1,i] ge 1 then $
    labels[i]=1 else labels[i]=-1
indices1 = where(labels[*] eq 1)
indices2 = where(labels[*] eq -1)

; perceptron algorithm
w = fltarr(2)
b = 0.0
R2 = max(total(data^2,1))
m = 1
while m gt 0 do begin
   m = 0
   for i=0,n-1 do begin
      gam = labels[i]*(w##transpose(data[*,i])+b)
      if gam le 0 then begin
         w=w+labels[i]*data[*,i]
         b=b+labels[i]*R2
         m = m+1
      endif
   endfor
endwhile

; plot the result
thisDevice =!D.Name
set_plot, 'PS'
Device, Filename='c:\temp\fig6_1.eps',xsize=3,ysize=3, $
         /inches,/encapsulated
plot, data[0,indices1], data[1,indices1], psym = 4
oplot, data[0,indices2], data[1,indices2], psym = 2
oplot, [0,1], [-b/w[1],-b/w[1]-w[0]/w[1]]
device,/close_file
set_plot,thisDevice

end