pro solution6_4

; simulated data in two dimensions with
; principal axis at 45 degrees
Xs = randomu(seed,1000,2,/normal)
Xs[0:499,0]=Xs[0:499,0]+3
Xs[0:499,1]=Xs[0:499,1]+3

; normalize
max_x = max(Xs)
min_x = min(Xs)
Xs = (Xs-min_x)/(max_x-min_x)

; train
FFN = Obj_New('FFNBP',Xs,Xs,1)
FFN->train

; recover hidden weights
wh = (FFN->GetWeights())[0:2]

; plot the result
thisDevice =!D.Name
set_plot, 'PS'
Device, Filename='c:\temp\fig6_2.eps',xsize=3,ysize=3, $
         /inches,/encapsulated
plot, Xs[*,0], Xs[*,1], psym=4
oplot, [0,1.0], [0,wh[2]/wh[1]]
device,/close_file
set_plot,thisDevice

end