pro solution7_2

envi_select, title='Choose multispectral image band', $
             fid=fid, dims=dims,pos=pos,/band_only
if (fid eq -1) then begin
   print, 'cancelled'
   return
endif

envi_file_query, fid, fname=fname

num_cols = dims[2]-dims[1]+1
num_rows = dims[4]-dims[3]+1
num_pixels = num_cols*num_rows

image = envi_get_data(fid=fid,dims=dims,pos=pos[0])

p = float(histogram(image,nbins=256))/num_pixels

i = where(p)

E = -total(p[i]*alog(p[i]))

print, 'Entropy for image '+fname
print, E

end

