; The travelling salesperson
function winner, g, W
   sz = size(W)
   GG = W*0.0
   for i=0,sz[2]-1 do $
      replicate_inplace, GG, g[i], 1, [0,i]
   D = total((W - GG)^2,2)
   return,(where(min(D) eq D))[0]
end
function dsquare, m, ks, k
   if abs(ks-k) lt (m/2) then return, $
   (ks-k)^2 else return, (m-abs(ks-k))^2
end
; main program
pro solution7_9
; coordinates of 10 cities on a unit square
cities = randomu(seed,10,2)
window, 11, xsize=600, ysize=400
wset,11
plot, cities[*,0], cities[*,1], psym=4, $
background= 'FFFFFF'X, color=0
; initialize 50 synaptic weights with random data
W = randomu(seed,50,2)
; train the network
print, 'training...'
etamax = 1.0
etamin = 0.001
sigmamax = 50/2.0
sigmamin = 0.5
progressbar = $
 Obj_New('progressbar', Color='blue', Text='0',$
 title= 'SOM training...',xsize=250,ysize=20)
progressbar->start
for i=0L,9999 do begin
   if progressbar->CheckCancel() then begin
      print,'training aborted'
      goto, done
   endif
   progressbar->Update,(i*100)/10000,text=strtrim(i,2)
   g = cities[i mod 10,*]
   kstar = winner(g, W)
   eta = etamax*(etamin/etamax)^(i/10000.0)
   sigma = sigmamax*(sigmamin/sigmamax)^(i/10000.0)
   for j=0L,49 do begin
      d2 = dsquare(50,kstar,j)
      lambda = exp(-d2/(2*sigma^2))
      W[j,*] = W[j,*] + eta*lambda*(g-W[j,*])
   endfor
endfor
done:
progressbar->destroy
oplot, W[*,0], W[*,1], color=0

end