#include <stdio.h>
#include "idl_export.h"

/*
;DLL for provisional means algorithm, called from the object
;class DEFINE__COVPM in order to avoid IDL for-loop.
;Compile using IDL procedure MAKE_DLL.
;Under MS Windows OS, use MAKE_PROV_MEANS.PRO,
;assuming VC++ 6.0 or later compiler is installed.
;For other OS, see IDL documentation for MAKE_DLL.
---------------------------------------------------------*/

int prov_means_natural(float *Xs, float *Ws,
     IDL_LONG NN, IDL_LONG n,
     float *sw, double *mn, double *cov)
{
/* loop over observation vectors */
float w, r;
IDL_LONG i,j,k;
float d[200];
for (i=0; i<n; i++)
  {
   w = *Ws;
   *sw += *Ws++;
   r = w/(*sw);
/* mean */
   for (j=0; j<NN; j++)
      {
        d[j] = Xs[i*NN+j]-mn[j];
        mn[j] += d[j]*r;
      }
/* covariance */
   for (j=0; j<NN; j++)
     for (k=0; k<NN; k++) cov[j*NN+k] += d[j]*d[k]*(1-r)*w;
 }
return(1);
}

/* glue */
int prov_means(int argc, void *argv[])
{
return prov_means_natural((float *) argv[0], (float *) argv[1],
    (IDL_LONG) argv[2], (IDL_LONG) argv[3],
    (float *) argv[4], (double *) argv[5], (double *) argv[6]);
}
/* -------------------------------------------------------- */

